/*eslint-disable no-var */


var fs = require('fs')
var path = require('path')
var webpack = require('webpack')

/*
import fs from 'fs'
import path from 'path'
import webpack from 'webpack'
import { fileURLToPath } from 'url';
*/

//const __filename = fileURLToPath(import.meta.url);

//const __dirname = path.dirname(__filename);
module.exports = {

  /*devtool: 'inline-source-map',*/

  entry: './src/index.tsx', 
  output: {
    path: path.resolve(__dirname, './lib'),
    filename: 'tuo-visual-document-react.js',
    // chunkFilename: '[id].chunk.js',
		libraryTarget: 'umd',//'umd','commomjs2'
		library: 'TuoVisualDocumentReact'
  },

  module: {
    rules: [
      {
        test: /\.js$|.jsx$|.ts$|.tsx$/,
        use: {
          loader : 'babel-loader',
          options: {
          	presets: [
              '@babel/preset-typescript',
              '@babel/preset-env',
              '@babel/preset-react'
            ],
          }
        }
      },
      {
        test: /\.css$/,
        use: [
          'style-loader',
          {
            loader: 'css-loader',
            options: {
              importLoaders: 1,
              modules: true
            }
          }
        ],
        include: /\.module\.css$/
      },
      {
        test : /\.css$/,
        use: ['style-loader', 'css-loader'],
        exclude: /\.module\.css$/
      },
      {
        test: /\.(jpg|png|svg)$/,
        loader: 'url-loader',
        options: {
          limit: 25000,
        },
      }
    ]
  },
  resolve: {
    extensions: ['.ts', '.js', '.tsx']
  },
  externals: {
    three: 'three',
    react: 'react',
    "react-dom": 'react-dom'
  },
  context: __dirname,
  mode: process.env.NODE_ENV === 'production' ? 'production': 'development',
  plugins: [
    new webpack.DefinePlugin({
      'process.env.NODE_ENV': JSON.stringify(process.env.NODE_ENV || 'development')
    }),
    new webpack.HotModuleReplacementPlugin()
  ]

}
